#  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
#  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
#  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
#  PARTICULAR PURPOSE.

# TESTED WITH PYTHON 3.9.5

import socket

# Set the device name , here "Evolis Primacy" as in Devices and Printer (ex : Evolis Zenius (Copy 1), ...)
data = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Rfv\", \"device\":\"Evolis Primacy\", \"timeout\":\"5000\"}}"

# Localhost and default TCP API mode port, TCP enabled, modify settings depending on your own configuration (IP of the server where the target Evolis Premium Suit is installed)
HOST, PORT = '127.0.0.1', 18000

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

try:
    # Connect to server and send data
    sock.connect((HOST, PORT))
    sock.sendall(bytes(data,encoding="utf-8"))


    # Receive data from Server
    received = sock.recv(1024)
    received = received.decode("utf-8")
    
    # shut down connection
finally:
    sock.close()

# Display sent request and answer from the server
print("Sent:     {}".format(data))
print("Received: {}".format(received))
