# README FILE 

## Disclaimer

All file in the Evolis SDk are used as "is" and is not warranted. Evolis cannot be held responsible of a misuse of provided code samples, utility or software. 

## Content 

* 10-begin.json - 11-getJobId.json : JSON requests specifically for an Evolis Premium Suite printer. 
    ** Command is based of the name of the printer (i.e Evolis Primacy), in order to change the name based on your current printer, refer to "API_How_to_use_JSON_requests" guide.

* 20-begin.json - 21-getJobId.json : JSON requests specifically for an Evolis Premium Suite 2 printer.
    ** Command is based of the name of the printer (i.e Evolis Primacy 2), in order to change the name based on your current printer, refer to "API_How_to_use_JSON_requests" guide.

The following requests are identical for EPS 1 and EPS2:

* 12-setSettings.json : JSON request used to specify the type of ribbon used. 
* 13-setFrontBitmapColor.json : JSON request used to specify the color of the image (front-face). 
* 14-setFrontBitmapBlack.json : JSON request used to specify the black portion of the image (front-face).
* 15-setFrontBitmapVarnish.json : JSON request used to specify the section where the varnish appears on the card (front-face).
* 16-setBackBitmapColor.json : JSON request used to specify the color of the image (back-face). 
* 17-setBackBitmapBlack.json : JSON request used to specify the black portion of the image (back-face).
* 18-setBackBitmapVarnish.json : JSON request used to specify the section where the varnish appears on the card (back-face).
    ** Images can be changed using the API_mode_how_to_create_custom_designs Guide.
* 19-print.json : JSON request used to send the print command.
* 20-end.json : JSON requests used to end the printing process.

** Use the 02_enable_disable_tcp_comm request to activate the TCP communication before running the TCP communication .bat file. 

* To test the requests for Evolis Services provider, run 
    - Color_print_double_side_PIPE.bat
        or 
    - Color_print_double_side_TCP.bat

* To test the requests for Evolis Services provider 2, run 
    - Color_print_dual_side_PIPE_ESP2.bat 
        or 
    - Color_print_dual_side_TCP_ESP2.bat 


* Resource folder : contains the base64 folder and a document that allows the user to create custom designs.
    * base64 folder : contains the design used for this requests set
    * Base64.exe is a small utility to encode graphics in base64 to be understandable by the API (to use only for that purpose).

* Results folder is the folder that records the request results.

** Reminder: The job ID can be customized, the current session being "MYTESTJOB" which can be modified according to the user's preference.

* EspfRequestTool.exe is a command line request tool to send requests to the Evolis Services provider API. We are using two different communication methods, for more details : read the GetStarted.pdf guide.