﻿// -----------------------------------------------------------------------
// <copyright file="SerializationTools.cs" company="Evolis Card Printer">
//     Copyright (c) Evolis Card Printer. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace ClientRuntime
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Linq;
    using System.Runtime.Serialization.Json;
    using System.Text;

    // 
    // --------------------------------------------------------------------------------
    // 
    public class SerializationTools
    {
        // 
        // --------------------------------------------------------------------------------
        // 
        public static string jsonSerialize(Object obj, Type type)
        {
            MemoryStream stream = new MemoryStream();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(type);
            serializer.WriteObject(stream, obj);
            stream.Position = 0;
            StreamReader reader = new StreamReader(stream);
            return reader.ReadToEnd();
        }

        // 
        // --------------------------------------------------------------------------------
        // 
        public static object jsonDeserialize(string objectData, Type type)
        {
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(type);

            object result;

            using (MemoryStream ms = new MemoryStream(System.Text.ASCIIEncoding.UTF8.GetBytes(objectData)))
            {
                result = serializer.ReadObject(ms);
            }

            return result;
        }
    }
}
