﻿// -----------------------------------------------------------------------
// <copyright file="EchoDemo.cs" company="Evolis Card Printer">
//     Copyright (c) Evolis Card Printer. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------


namespace EchoDemo
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Data;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using System.Windows.Forms;
    using ClientRuntime;

    //
    // ------------------------------------------------------------------
    //
    public partial class EchoDemo: UserControl
    {
        //
        // --------------------------------------------------------------
        //
        public EchoDemo()
        {
            InitializeComponent();
        }

        //
        // --------------------------------------------------------------
        //
        private void button1_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";
            textBox3.Text = "";

            try
            {
                textBox4.Text = BusinessHelper.SendEcho((string)textBox1.Text);
                textBox2.Text = EspfClientProcessor.LastRequest;
                textBox3.Text = EspfClientProcessor.LastAnswer;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }

        //
        // --------------------------------------------------------------
        //
        private void UpdateColor()
        {
            this.ForeColor = BusinessHelper.FgColor;
            this.BackColor = BusinessHelper.BgColor;

            textBox1.ForeColor = BusinessHelper.FgColor;
            textBox1.BackColor = BusinessHelper.BgColor;
            textBox2.ForeColor = BusinessHelper.FgColor;
            textBox2.BackColor = BusinessHelper.BgColor;
            textBox3.ForeColor = BusinessHelper.FgColor;
            textBox3.BackColor = BusinessHelper.BgColor; 
            textBox4.ForeColor = BusinessHelper.FgColor;
            textBox4.BackColor = BusinessHelper.BgColor;

        }

        //
        // --------------------------------------------------------------
        //
        private void EchoDemo_Paint(object sender, PaintEventArgs e)
        {
            UpdateColor();
        }

    }
}
