﻿// -----------------------------------------------------------------------
// <copyright file="PrinterSelector.cs" company="Evolis Card Printer">
//     Copyright (c) Evolis Card Printer. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace PrinterSelector
{
    using ClientRuntime;
    using System;
    using System.Collections.Generic;
    using System.Drawing;
    using System.IO;
    using System.Windows.Forms;

    //
    // ------------------------------------------------------------------
    //
    public partial class PrinterSelector : UserControl
    {
        //
        // --------------------------------------------------------------
        //
        public PrinterSelector(bool isRequestVisible)
        {
            InitializeComponent();

            try
            {
                label3.Visible = false;
                label4.Visible = false;
                textBox2.Visible = false;
                textBox3.Visible = false;

                this.Size = new Size(700, 150);

                if (!isRequestVisible)
                {
                    button3.Visible = false;
                }
            }
            catch (Exception ex)
            {

            }            
        }

        //
        // --------------------------------------------------------------
        //
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            BusinessHelper.Model = comboBox1.Text;
            textBox2.Text = "";
            textBox3.Text = "";
            comboBox2.Items.Clear();
            string[] printerList = BusinessHelper.GetSupervisedPrinter((string)comboBox1.Text, "0"); 
            if (printerList != null)
            {
                comboBox2.Items.Clear();
                comboBox2.Items.AddRange(printerList);
                comboBox2.SelectedIndex = 0;
                textBox2.Text = EspfClientProcessor.LastRequest;
                textBox3.Text = EspfClientProcessor.LastAnswer;
            }
        }

        //
        // --------------------------------------------------------------
        //
        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            BusinessHelper.Printer = comboBox2.Text;
        }

        //
        // --------------------------------------------------------------
        //
        private void button3_Click(object sender, EventArgs e)
        {
            textBox2.Visible = !textBox2.Visible;
            if (textBox2.Visible)
            {
                button3.Text = "Hide Request";
                label3.Visible = true;
                label4.Visible = true;
                textBox2.Visible = true;
                textBox3.Visible = true;
                this.Size = new Size(700, 500);
            }
            else
            {
                button3.Text = "Show Request";
                label3.Visible = false;
                label4.Visible = false;
                textBox2.Visible = false;
                textBox3.Visible = false;
                this.Size = new Size(700, 150);
            }
        }

        //
        // --------------------------------------------------------------
        //
        private void PrinterSelector_Paint(object sender, PaintEventArgs e)
        {
            UpdateColor();
        }

        //
        // --------------------------------------------------------------
        //
        private void UpdateColor()
        {
            this.ForeColor = BusinessHelper.FgColor;
            this.BackColor = BusinessHelper.BgColor;

            textBox2.ForeColor = BusinessHelper.FgColor;
            textBox2.BackColor = BusinessHelper.BgColor;

            textBox3.ForeColor = BusinessHelper.FgColor;
            textBox3.BackColor = BusinessHelper.BgColor;

            comboBox1.ForeColor = BusinessHelper.FgColor;
            comboBox1.BackColor = BusinessHelper.BgColor;

            comboBox2.ForeColor = BusinessHelper.FgColor;
            comboBox2.BackColor = BusinessHelper.BgColor;
        }

        //
        // --------------------------------------------------------------
        //

        private void PrinterSelector_Load(object sender, EventArgs e)
        {
            FileInfo myFile = new FileInfo("printerlist.txt");
            if (myFile.Exists)
            {
                List<string> myList = new List<string>();

                StreamReader myStream = new StreamReader(myFile.FullName);
                do
                {
                    myList.Add(myStream.ReadLine());

                } while (!myStream.EndOfStream);

                this.comboBox1.Items.Clear();
                this.comboBox1.Items.AddRange(myList.ToArray());
                this.comboBox1.SelectedItem = BusinessHelper.Model;

                comboBox2.Items.Clear();
                string[] printerList = BusinessHelper.GetSupervisedPrinter((string)comboBox1.Text, "0");
                if (printerList != null)
                {
                    comboBox2.Items.Clear();
                    comboBox2.Items.AddRange(printerList);
                    comboBox2.SelectedIndex = 0;
                }
            }
        }
    }
}