﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClientRuntime;
using ClientRuntime.EspfRequest;
using System.IO;

namespace SettingDemo
{
    public partial class SettingDemo : UserControl
    {
        private string session;

        public SettingDemo()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
            session = "";
        }

        private void UpdateColor()
        {
            this.ForeColor = BusinessHelper.FgColor;
            this.BackColor = BusinessHelper.BgColor;
            //this.button1.BackColor = this.BackColor;
            this.textBox1.ForeColor = BusinessHelper.FgColor;
            this.textBox1.BackColor = BusinessHelper.BgColor;
            this.textBox2.ForeColor = BusinessHelper.FgColor;
            this.textBox2.BackColor = BusinessHelper.BgColor;
            this.comboBox1.ForeColor = BusinessHelper.FgColor;
            this.comboBox1.BackColor = BusinessHelper.BgColor;
            this.comboBox2.ForeColor = BusinessHelper.FgColor;
            this.comboBox2.BackColor = BusinessHelper.BgColor;
            this.button1.ForeColor = BusinessHelper.FgColor;
            this.button2.ForeColor = BusinessHelper.FgColor;
            this.button3.ForeColor = BusinessHelper.FgColor;
            this.button4.ForeColor = BusinessHelper.FgColor;
            this.button5.ForeColor = BusinessHelper.FgColor;
            this.button6.ForeColor = BusinessHelper.FgColor;
            this.button8.ForeColor = BusinessHelper.FgColor;
            this.button1.BackColor = BusinessHelper.BgColor;
            this.button2.BackColor = BusinessHelper.BgColor;
            this.button3.BackColor = BusinessHelper.BgColor;
            this.button4.BackColor = BusinessHelper.BgColor;
            this.button5.BackColor = BusinessHelper.BgColor;
            this.button6.BackColor = BusinessHelper.BgColor;
            this.button8.BackColor = BusinessHelper.BgColor;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        private void btnImport_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
            textBox2.Text = "";

            if (comboBox1.Text == "xml")
            {
                OpenFileDialog ofd = new OpenFileDialog();
                DialogResult result = ofd.ShowDialog();
                ofd.Filter = "DAT files|*.dat|All Files (*.*)|*.*";
                if (result == DialogResult.OK)
                {
                    textBox1.Text = "Loading ...";
                    System.IO.StreamReader sr = new System.IO.StreamReader(ofd.FileName);
                    byte[] buffer = BusinessHelper.ReadFully(sr.BaseStream, 0);
                    sr.Close();
                    string base64Str = "base64:" + System.Convert.ToBase64String(buffer);

                    string id = "SETTING546";
                    EspfParamsSetting p = new EspfParamsSetting() { session = this.session, format = comboBox1.Text, data = base64Str };

                    try
                    {
                        EspfClientProcessor.Send(BusinessHelper.IP, BusinessHelper.Port, BusinessHelper.CommProcType,
                           new EspfSetting() { method = "SETTING.Import", id = id, parameters = p });
                        textBox1.Text = "DAT File imported";
                        textBox2.Text = EspfClientProcessor.LastAnswer;
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    }                                        
                }
            }
            else
            {
                string id = "SETTING886";
                EspfParamsSetting p = new EspfParamsSetting() { session = this.session, format = comboBox1.Text };

                try
                {
                    EspfClientProcessor.Send(BusinessHelper.IP, BusinessHelper.Port, BusinessHelper.CommProcType,
                               new EspfSetting() { method = "SETTING.Import", id = id, parameters = p });
                    textBox1.Text = EspfClientProcessor.LastRequest;
                    textBox2.Text = EspfClientProcessor.LastAnswer;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }                                        
            }
        }

        private void btnBegin_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
            textBox2.Text = "";

            string id = "SETTING866";
            EspfParamsSetting p = new EspfParamsSetting() { device = BusinessHelper.Printer };
                        
            try
            {
                this.session = EspfClientProcessor.Send(BusinessHelper.IP, BusinessHelper.Port, BusinessHelper.CommProcType,
                           new EspfSetting() { method = "SETTING.Begin", id = id, parameters = p });
                textBox1.Text = EspfClientProcessor.LastRequest;
                textBox2.Text = EspfClientProcessor.LastAnswer;    
            }
            catch (Exception ex)
            {
                MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }

        private void btnEnd_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
            textBox2.Text = "";

            string id = "SETTING425";
            EspfParamsSetting p = new EspfParamsSetting() { session = this.session };

            try
            {
                EspfClientProcessor.Send(BusinessHelper.IP, BusinessHelper.Port, BusinessHelper.CommProcType,
                           new EspfSetting() { method = "SETTING.End", id = id, parameters = p });

                textBox1.Text = EspfClientProcessor.LastRequest;
                textBox2.Text = EspfClientProcessor.LastAnswer;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }

        private void btnGet_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";

            string id = "SETTING444";
            EspfParamsSetting p = new EspfParamsSetting() { session = this.session, data = "[Choose your Setting]" };

            EspfSetting req = new EspfSetting() { method = "SETTING.Get", id = id, parameters = p };
            textBox1.Text = (string.IsNullOrEmpty(session)) ? "Click BEGIN first" : SerializationTools.jsonSerialize(req, req.GetType());
        }

        private void btnSet_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";

            string id = "SETTING889";
            EspfParamsSetting p = new EspfParamsSetting() { session = this.session, data = "[key=value]" }; 

            EspfSetting req = new EspfSetting() { method = "SETTING.Set", id = id, parameters = p };
            textBox1.Text = (string.IsNullOrEmpty(session)) ? "Click BEGIN first" : SerializationTools.jsonSerialize(req, req.GetType());
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";
            textBox2.Text = EspfClientProcessor.SendRequest(BusinessHelper.CommProcType, BusinessHelper.IP, BusinessHelper.Port, textBox1.Text);
        }

        private void SettingDemo_Paint(object sender, PaintEventArgs e)
        {
            UpdateColor();
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
            textBox2.Text = "";

            if (comboBox2.Text == "xml")
            {
                string id = "SETTING334";
                EspfParamsSetting p = new EspfParamsSetting() { session = this.session, format = comboBox2.Text };

                try
                {
                    string base64Str = EspfClientProcessor.Send(BusinessHelper.IP, BusinessHelper.Port, BusinessHelper.CommProcType,
                               new EspfSetting() { method = "SETTING.Export", id = id, parameters = p });
                    // Remove base64: from result
                    byte[] buffer = System.Convert.FromBase64String(base64Str.Remove(0, 7));
                    BinaryWriter bw = new BinaryWriter(new FileStream("example.dat", FileMode.Create));
                    bw.Write(buffer);
                    bw.Close();
                    textBox1.Text = EspfClientProcessor.LastRequest;
                    textBox2.Text = "File 'example.dat' saved";
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }
            }
            else
            {
                string id = "SETTING992";
                EspfParamsSetting p = new EspfParamsSetting() { session = this.session, format = comboBox2.Text };

                try
                {
                    EspfClientProcessor.Send(BusinessHelper.IP, BusinessHelper.Port, BusinessHelper.CommProcType,
                               new EspfSetting() { method = "SETTING.Export", id = id, parameters = p });
                    textBox1.Text = EspfClientProcessor.LastRequest;

                    textBox2.Text = EspfClientProcessor.LastAnswer;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }
            }
        }
    }
}
