﻿// -----------------------------------------------------------------------
// <copyright file="SingleCommand.cs" company="Evolis Card Printer">
//     Copyright (c) Evolis Card Printer. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------


namespace SingleCommand
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Data;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using System.Windows.Forms;
    using ClientRuntime;

    //
    // ------------------------------------------------------------------
    //
    public partial class SingleCommand : UserControl
    {
        private bool isRequestVisible;

        //
        // --------------------------------------------------------------
        //
        public SingleCommand()
        {
            InitializeComponent();
            textBox5.Text = "5000";
            textBox1.Text = "Rok";
            isRequestVisible = false;
            button3.Text = "Show Request";
            label2.Visible = isRequestVisible;
            label3.Visible = isRequestVisible;
            textBox2.Visible = isRequestVisible;
            textBox3.Visible = isRequestVisible;
        }

        //
        // --------------------------------------------------------------
        //
        private void button1_Click(object sender, EventArgs e)
        {
            SendCommand();
        }

        //
        // --------------------------------------------------------------
        //
        private void SendCommand()
        {
            textBox2.Text = "";
            textBox3.Text = "";
            try
            {
                textBox4.Text = BusinessHelper.SendCommand(BusinessHelper.Printer, textBox1.Text, textBox5.Text);
                textBox2.Text = EspfClientProcessor.LastRequest;
                textBox3.Text = EspfClientProcessor.LastAnswer;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }            
        }

        //
        // --------------------------------------------------------------
        //
        private void button3_Click(object sender, EventArgs e)
        {
            isRequestVisible = !isRequestVisible;
            label2.Visible = isRequestVisible;
            label3.Visible = isRequestVisible;
            textBox2.Visible = isRequestVisible;
            textBox3.Visible = isRequestVisible;

            button3.Text = (isRequestVisible) ? "Hide Request" : "Show Request";
        }

        //
        // --------------------------------------------------------------
        //
        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                SendCommand();
            }
        }

        //
        // --------------------------------------------------------------
        //
        private void button2_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";
            textBox3.Text = "";
            OpenFileDialog ofd = new OpenFileDialog();
            DialogResult result = ofd.ShowDialog();
            ofd.Filter = "PRN files|*.prn|All Files (*.*)|*.*";
            if (result == DialogResult.OK)
            {
                System.IO.StreamReader sr = new System.IO.StreamReader(ofd.FileName);
                byte[] buffer = BusinessHelper.ReadFully(sr.BaseStream, 0);
                sr.Close();
                string base64Str = System.Convert.ToBase64String(buffer);
                try
                {
                    textBox4.Text = BusinessHelper.SendCommand(BusinessHelper.Printer, "base64:" + base64Str, textBox5.Text);
                    textBox2.Text = EspfClientProcessor.LastRequest;
                    textBox3.Text = EspfClientProcessor.LastAnswer;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }                    
            }
        }

        //
        // --------------------------------------------------------------
        //
        private void button4_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";
            textBox3.Text = "";
            try
            {
                textBox4.Text = BusinessHelper.GetStatus(BusinessHelper.Printer);
                textBox2.Text = EspfClientProcessor.LastRequest;
                textBox3.Text = EspfClientProcessor.LastAnswer;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Cannot send request !", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }   
        }

        //
        // --------------------------------------------------------------
        //
        private void SingleCommand_Paint(object sender, PaintEventArgs e)
        {
            UpdateColor();
        }

        //
        // --------------------------------------------------------------
        //
        private void UpdateColor()
        {
            this.ForeColor = BusinessHelper.FgColor;
            this.BackColor = BusinessHelper.BgColor;

            textBox1.ForeColor = BusinessHelper.FgColor;
            textBox1.BackColor = BusinessHelper.BgColor;

            textBox2.ForeColor = BusinessHelper.FgColor;
            textBox2.BackColor = BusinessHelper.BgColor;

            textBox3.ForeColor = BusinessHelper.FgColor;
            textBox3.BackColor = BusinessHelper.BgColor;

            textBox4.ForeColor = BusinessHelper.FgColor;
            textBox4.BackColor = BusinessHelper.BgColor;

            textBox5.ForeColor = BusinessHelper.FgColor;
            textBox5.BackColor = BusinessHelper.BgColor;
        }
    }
}
