﻿// -----------------------------------------------------------------------
// <copyright file="MainWindows.cs" company="Evolis Card Printer">
//     Copyright (c) Evolis Card Printer. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace demo
{
    using ClientRuntime;
    using System;
    using System.Windows.Forms;

    // 
    // --------------------------------------------------------------------------------
    // 
    public partial class MainWindows : Form
    {
        public StateDemo.StateDemo sd;

        // 
        // ----------------------------------------------------------------------------
        // 
        public MainWindows()
        {
            InitializeComponent();

            UpdateColor();

            ParametersControl.ParametersControl ui = new ParametersControl.ParametersControl();
            sd = new StateDemo.StateDemo();
            sd.Height = this.Height - 120;
            sd.Width = this.Width - 40;
            PrinterSelector.PrinterSelector ps = new PrinterSelector.PrinterSelector(true);
            EchoDemo.EchoDemo ed = new EchoDemo.EchoDemo();
            SingleCommand.SingleCommand sc = new SingleCommand.SingleCommand();
            GenericRequest.GenericRequest gr = new GenericRequest.GenericRequest();
            ui.Dock = DockStyle.Fill;
            this.tabPage1.Controls.Add(ui);
            ui.notifyColorChange += new ParametersControl.ParametersControl.ColorChangeHandler(OnColorChange);
            this.flowLayoutPanel1.Controls.Add(sd);
            this.flowLayoutPanel2.Controls.Add(ed);
            this.flowLayoutPanel3.Controls.Add(ps);
            this.flowLayoutPanel3.Controls.Add(sc);
            this.flowLayoutPanel4.Controls.Add(gr);
            PrintDemo.PrintDemo pdem = new PrintDemo.PrintDemo();
            this.tabPage6.Controls.Add(pdem);
            pdem.Dock = DockStyle.Fill;

            SettingDemo.SettingDemo sdem = new SettingDemo.SettingDemo();
            this.tabPage7.Controls.Add(sdem);
            sdem.Dock = DockStyle.Fill;
        }

        private void UpdateColor()
        {
            this.ForeColor = BusinessHelper.FgColor;
            this.BackColor = BusinessHelper.BgColor;

            this.flowLayoutPanel1.BackColor = BusinessHelper.BgColor;
            this.flowLayoutPanel2.BackColor = BusinessHelper.BgColor;
            this.flowLayoutPanel3.BackColor = BusinessHelper.BgColor;
            this.flowLayoutPanel4.BackColor = BusinessHelper.BgColor;

            this.tabPage1.BackColor = BusinessHelper.BgColor;
            this.tabPage1.ForeColor = BusinessHelper.FgColor;
            this.tabPage5.BackColor = BusinessHelper.BgColor;
            this.tabPage5.ForeColor = BusinessHelper.FgColor;
            this.tabPage3.BackColor = BusinessHelper.BgColor;
            this.tabPage3.ForeColor = BusinessHelper.FgColor;
            this.tabPage4.BackColor = BusinessHelper.BgColor;
            this.tabPage4.ForeColor = BusinessHelper.FgColor;
            this.tabPage2.BackColor = BusinessHelper.BgColor;
            this.tabPage2.ForeColor = BusinessHelper.FgColor;
            this.tabPage6.BackColor = BusinessHelper.BgColor;
            this.tabPage6.ForeColor = BusinessHelper.FgColor;
            this.tabPage7.BackColor = BusinessHelper.BgColor;
            this.tabPage7.ForeColor = BusinessHelper.FgColor;

            this.tabControl1.BackColor = BusinessHelper.BgColor;
            this.tabControl1.ForeColor = BusinessHelper.FgColor;
        }

        // 
        // ---------------------------------------------------------------------------
        // 
        private void OnColorChange(ParametersControl.ParametersControl pui, EventArgs e)
        {
            UpdateColor();
            this.Refresh();
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        private void tabControl1_Selected(object sender, TabControlEventArgs e)
        {
             if (e.TabPage.Text == "STATE")
             {
                 if ((sd != null) && (sd.MyTimer != null)) sd.MyTimer.Start();
                 if ((sd != null) && (sd.MyTimer2 != null)) sd.MyTimer2.Start();
             }
             else
             {
                 if ((sd != null) && (sd.MyTimer != null)) sd.MyTimer.Stop();
                 if ((sd != null) && (sd.MyTimer2 != null)) sd.MyTimer2.Stop();
             }
        }

        private void MainWindows_Paint(object sender, PaintEventArgs e)
        {
            UpdateColor();
        }
    }
}
