#include "FileBuffer.h"

/* ----------------------------------------------------------- */

void loadBufferFromFile(char* filename, char** buffer, size_t* size)
{
	FILE *instream;
	errno_t err;
	int  fileLen;

	*size = 0;
	*buffer = NULL;

	if ((err = fopen_s(&instream, filename, "rb")) != 0)
	{
		fprintf(stderr, "Unable to open input file\n");
		return;
	}

	fseek(instream, 0, SEEK_END);
	fileLen = ftell(instream);
	fseek(instream, 0, SEEK_SET);

	*buffer = (char*) malloc(fileLen);
	if (NULL == *buffer)
	{
		fprintf(stderr, "Error memory allocation\n");
		fclose(instream);
		return;
	}

	*size = fread(*buffer, 1, fileLen, instream);
	
	if (fileLen != *size)
	{
		fprintf(stderr, "Incomplete reading (file size: %lu, buffer size:%lu)\n", fileLen+1, *size);
	}

	fclose(instream);

}

/* ----------------------------------------------------------- */

int saveBufferToFile(char* filename, char* buffer, size_t size)
{
	FILE *outstream;
	errno_t err;
	size_t wrote;
	int ret = 0;

	if ((err = fopen_s(&outstream, filename, "wb") != 0))
	{
		fprintf(stderr, "Unable to open output file\n");
		return 1;
	}

	wrote = fwrite(buffer, 1, size, outstream);

	if (wrote != size)
	{
		fprintf(stderr, "Incomplete writing (file size: %lu, buffer size:%lu)\n", size, wrote);
		ret = 1;
	}

	fclose(outstream);
	return ret;
}