# README FILE 

## Disclaimer

All file in the Evolis SDK are used as "is" and is not warranted. Evolis cannot be held responsible of a misuse of provided code samples, utility or software. 

# CONTENT:

* 00_Requests : JSON requests 
    * 00_full_session : Contains JSON requests example of a complete printing and encoding session.
    * 01_get_printer_status: Request used to get the current status of the printer.
    * 02_enable_disable_tcp_comm : Request used to enable or disable the TCP communication with the printer.
    * 03_echo : Request used to send an echo test string (e.g. "HELLO SERVER!") to the service provider (ESP) and (ESP2).
    * 04_restart_printer : Request used to restart the printer.
    * 05_restart_service_provider : Request used to restart the service provider (ESP) and (ESP2).
    * 06_insert_eject_card : Request used to insert and eject a card.
    * 07_read_firmware_move_motor : Request used to read the current firmware version and move the fan motor.
    * 08_monochrome_print_one_side : Request used to execute a one-sided black printing session.
    * 09_monochrome_print_double_side : Request used to execute a double-sided black printing session.
    * 10_color_print_one_side : Request used to execute a one-sided color printing session.
    * 11_color_print_double_side : Request used to execute a double-sided color printing session.
    * 12_magnetic_encoding : Request used to execute a magnetic encoding session.
    * 13_scan : Request used to execute a one-sided scanning session.
    * 14_rewrite_one_side : Request used to execute a one-sided color rewriting session.
    * 15_rewrite_double_side : Request used to execute a double-sided rewriting session.

* 01_Demo : Contains the source code of the demo program "Demo". 
    By default: Evolis Service Provider 2 - PARAM: (Pipe name: Espf2Server00) 
            For Evolis Service Provider - PARAM: (Pipe name: EspfServer00)
        After changing the pipe name in the PARAM tab and the driver in the COMMAND tab, the software will automatically detect the printers registered by the PC.

* 02_Utilities : Contains the Evolis ESPF Request Tool.

* C / C sharp / Delphi / Java / Pascal / Vb.net : Contains a minimal client file used to communicate with an Evolis device thanks to a TCP channel.

* Python : Contains Python file with examples on how to do a few general tasks, the communication with an Evolis device is possible thanks to a TCP channel.
    * Color_print_double_sided : folder containing python file and text files with the image data converted in base64 code.
    * Magnetic_Encoding.py
    * Send_Command.py

* Guides on how to manage the API mode functions of the printer.
