//  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
//  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
//  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
//  PARTICULAR PURPOSE.

#include <stdlib.h>
#include <stdio.h>

#ifdef WIN32  
#include <ws2tcpip.h>
#elif defined (_UNIX)
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#define INVALID_SOCKET -1
#define SOCKET_ERROR -1
#define closesocket(s) close(s)
typedef int SOCKET;
typedef struct sockaddr_in SOCKADDR_IN;
typedef struct sockaddr SOCKADDR;
typedef struct in_addr IN_ADDR;
#else
#error OS not supported
#endif

#include <errno.h>
#include <string.h>
#include <sys/types.h>

// Need to link with Ws2_32.lib, Mswsock.lib, and Advapi32.lib
#ifdef WIN32  
#pragma comment (lib, "Ws2_32.lib")
#pragma comment (lib, "Mswsock.lib")
#pragma comment (lib, "AdvApi32.lib")
#endif

int main()
{
#ifdef WIN32
	WSADATA wsa;
#endif
	int sockfd, numbytes;
	byte data[1024] = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Mc;+;1000\", \"device\":\"Evolis Primacy\", \"timeout\":\"5000\"}}";  //this request must be encoded in UTF-8
	char answer[1024] = {0};
	char ipdest[16] = "11.1.24.124";
	int port = 18000;
	struct sockaddr_in their_addr; 

#ifdef WIN32
	WSAStartup(MAKEWORD(2, 2), &wsa);
#endif

	if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	their_addr.sin_family = AF_INET;
	inet_pton(AF_INET, ipdest, &their_addr.sin_addr);
	their_addr.sin_port = htons(port);

	if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof their_addr) == -1)
	{
		perror("connect");
		exit(1);
	}

	if (send(sockfd, data, strlen(data), 0) == -1) {
		perror("send");
		exit(1);
	}

	shutdown(sockfd, 1);


	if ((numbytes = recv(sockfd, answer, (int)strlen(answer), 0)) == -1) {
		perror("recv");
		exit(1);
	}

	answer[numbytes] = '\0';

	printf("Received: %s\n", answer);

	closesocket(sockfd);

	puts("Press ENTER to continue ...\n");
	getchar();

#ifdef WIN32
	WSACleanup();
#endif
	return 0;
}