﻿//  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
//  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
//  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
//  PARTICULAR PURPOSE.

namespace MinimalClient
{
    using System;
    using System.Net.Sockets;
    using System.Text;
    using System.Threading;

    public static class MinimalClient
    {
        public static void Main()
        {
			try 
			{
				string ip = "11.1.24.210";
				int port = 18000;
                int received = 0;
                byte[] data = new byte[1024];
                int recv = 0;
                bool hasAnswers = false;
                string answer = string.Empty;

				TcpClient client = new TcpClient(ip, port);

				NetworkStream ns = client.GetStream();

				byte[] request = Encoding.UTF8.GetBytes("{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Rfv\", \"device\":\"Evolis Primacy\", \"timeout\":\"5000\"}}");

				ns.Write(request, 0, request.Length);

				ns.Flush();

                while ((ns.DataAvailable) || (!hasAnswers))
                {
                    recv = ns.Read(data, 0, data.Length);
                    received += recv;
                    answer += Encoding.UTF8.GetString(data, 0, recv);
                    hasAnswers = true;
                    Thread.Sleep(10);
                }

                Console.WriteLine(answer);

				ns.Close();

				client.Close();

				Console.WriteLine("Press a key to continue ...");
				Console.ReadKey();
			}
        	catch (Exception) 
			{ 
        		Console.WriteLine("Communication failed :\n");
				Console.WriteLine(" - check TCP communication is activated\n");
				Console.WriteLine(" - check the service is activated\n");
				Console.WriteLine(" - check your IP address and port\n");				
			}
        }
    }
}