#  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
#  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
#  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
#  PARTICULAR PURPOSE.

# TESTED WITH PYTHON 3.9.5

import socket

# Opening the text file that contains the base64 code for the image

# Front-face card variables
with open('CFrontColorData.txt', 'r') as file:
    FcolorData = file.read()

with open('CFrontResinData.txt', 'r') as file:
    FresinData = file.read()

with open('CFrontVarnishData.txt', 'r') as file:
    FvarnishData = file.read()

# Back-face card variables
with open('CBackColorData.txt', 'r') as file:
    BcolorData = file.read()

with open('CBackResinData.txt', 'r') as file:
    BresinData = file.read()

with open('CBackVarnishData.txt', 'r') as file:
    BvarnishData = file.read()


for x in range(2):

    # Set the device name , here "Evolis Primacy" as in Devices and Printer (ex : Evolis Zenius (Copy 1), ...)
    data1 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Ss\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"

    data2 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.Begin\",\"params\":{\"device\":\"Evolis Primacy 2\", \"session\":\"MYTESTJOB\"}}"
    data3 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.Set\",\"params\":{\"data\":\"IGSendSpoolerSession=OFF;GRibbonType=RC_YMCKO;Duplex=HORIZONTAL;GDuplexType=DUPLEX_CC\", \"session\":\"MYTESTJOB\"}}"

    # Importing and using the images in base64 code (front and back)
    data4 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.SetBitmap\",\"params\":{\"session\":\"MYTESTJOB\", \"face\":\"front\", \"panel\":\"color\", \"data\":"  +'"' + FcolorData +'"' +"}}"
    data4 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.SetBitmap\",\"params\":{\"session\":\"MYTESTJOB\", \"face\":\"front\", \"panel\":\"resin\", \"data\":"  +'"' + FresinData +'"' +"}}"
    data6 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.SetBitmap\",\"params\":{\"session\":\"MYTESTJOB\", \"face\":\"front\", \"panel\":\"varnish\", \"data\":"  +'"' + FvarnishData +'"' +"}}"
    data7 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.SetBitmap\",\"params\":{\"session\":\"MYTESTJOB\", \"face\":\"back\", \"panel\":\"color\", \"data\":"  +'"' + BcolorData +'"' +"}}"
    data8 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.SetBitmap\",\"params\":{\"session\":\"MYTESTJOB\", \"face\":\"back\", \"panel\":\"resin\", \"data\":"  +'"' + BresinData +'"' +"}}"
    data9 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.SetBitmap\",\"params\":{\"session\":\"MYTESTJOB\", \"face\":\"back\", \"panel\":\"varnish\", \"data\":"  +'"' + BvarnishData +'"' +"}}"

    # Ending printing session
    data10 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.Print\",\"params\":{\"session\":\"MYTESTJOB\"}}"
    data11 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"PRINT.End\",\"params\":{\"session\":\"MYTESTJOB\"}}"

    # Localhost and default TCP API mode port, TCP enabled, modify settings depending on your own configuration (IP of the server where the target Evolis Premium Suit is installed)
    HOST, PORT = '127.0.0.1', 18200

    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    try:
        # Connect to server and send data
        sock.connect((HOST, PORT))

        sock.sendall(bytes(data1, encoding="utf-8"))

        # Receive data from Server
        received1 = sock.recv(1024)
        received1 = received1.decode("utf-8")

        sock.sendall(bytes(data2, encoding="utf-8"))

        # Receive data from Server
        received2 = sock.recv(1024)
        received2 = received2.decode("utf-8")

        sock.sendall(bytes(data3, encoding="utf-8"))

        # Receive data from Server
        received3 = sock.recv(1024)
        received3 = received3.decode("utf-8")

        sock.sendall(bytes(data4, encoding="utf-8"))

        # Receive data from Server
        received4 = sock.recv(1024)
        received4 = received4.decode("utf-8")
        
        sock.sendall(bytes(data5, encoding="utf-8"))
        #
        # Receive data from Server
        received5 = sock.recv(1024)
        received5 = received5.decode("utf-8")

        sock.sendall(bytes(data6, encoding="utf-8"))

        # Receive data from Server
        received6 = sock.recv(1024)
        received6 = received6.decode("utf-8")

        sock.sendall(bytes(data7, encoding="utf-8"))

        # Receive data from Server
        received7 = sock.recv(1024)
        received7 = received7.decode("utf-8")

        sock.sendall(bytes(data8, encoding="utf-8"))

        # Receive data from Server
        received8 = sock.recv(1024)
        received8 = received8.decode("utf-8")

        sock.sendall(bytes(data9, encoding="utf-8"))

        # Receive data from Server
        received9 = sock.recv(1024)
        received9 = received9.decode("utf-8")

        sock.sendall(bytes(data10, encoding="utf-8"))

        # Receive data from Server
        received10 = sock.recv(1024)
        received10 = received10.decode("utf-8")

        sock.sendall(bytes(data11, encoding="utf-8"))

        # Receive data from Server
        received11 = sock.recv(1024)
        received11 = received11.decode("utf-8")


    finally:
        sock.close()
        print(x)

    # Display sent request and answer from the server
    print("Sent:     {}".format(data1))
    print("Received: {}".format(received1))

    print("//////////// TEST //////////////")
    print("Sent:     {}".format(data2))
    print("Received: {}".format(received2))

    print("//////////// RIBBON TYPE //////////////")
    print("Sent:     {}".format(data3))
    print("Received: {}".format(received3))

    print("//////////// FRONT COLOR //////////////")
    print("Sent:     {}".format(data4))
    print("Received: {}".format(received4))

    print("//////////// FRONT BLACK //////////////")
    print("Sent:     {}".format(data5))
    print("Received: {}".format(received5))

    print("//////////// FRONT VARNISH //////////////")
    print("Sent:     {}".format(data6))
    print("Received: {}".format(received6))

    print("//////////// BACK COLOR //////////////")
    print("Sent:     {}".format(data7))
    print("Received: {}".format(received7))

    print("//////////// BACK COLOR //////////////")
    print("Sent:     {}".format(data8))
    print("Received: {}".format(received8))

    print("//////////// BACK COLOR //////////////")
    print("Sent:     {}".format(data9))
    print("Received: {}".format(received9))

    print("//////////// PRINT //////////////")
    print("Sent:     {}".format(data10))
    print("Received: {}".format(received10))

    print("//////////// END //////////////")
    print("Sent:     {}".format(data11))
    print("Received: {}".format(received11))

