#  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
#  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
#  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
#  PARTICULAR PURPOSE.

# TESTED WITH PYTHON 3.9.5

import socket

# Set the device name , here "Evolis Primacy" as in Devices and Printer (ex : Evolis Zenius (Copy 1), ...)
data = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Rfv\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data1 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Mc;+;2000\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data2 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"SUPERVISION.List\",\"params\":{\"device\":\"Evolis Primacy 2\", \"level\":\"2\"}}"

# Magnetic encoding - Instancing data on the tracks
data3 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Pmc;h\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data4 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Pmt;1;1\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data5 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Pmt;2;2\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data6 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Pmt;3;3\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data7 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Ss\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"

# Write data for the 3 tracks
data8 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Dm;1;EVOLISCARDSERVICE\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data9 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Dm;2;10022021\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data10 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Dm;3;01001101\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"

# Writing and ending the command
data11 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Smw\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data12 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Smr;1\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data13 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Se\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
data14 = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Seb\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"


# Localhost and default TCP API mode port, TCP enabled, modify settings depending on your own configuration (IP of the server where the target Evolis Premium Suit is installed)
HOST, PORT = '127.0.0.1', 18200

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

try:
    # Connect to server and send data
    sock.connect((HOST, PORT))
    sock.sendall(bytes(data, encoding="utf-8"))

    # Receive data from Server
    received = sock.recv(1024)
    received = received.decode("utf-8")

    # Connect to server and send data
    sock.sendall(bytes(data1, encoding="utf-8"))

    # Receive data from Server
    received1 = sock.recv(1024)
    received1 = received1.decode("utf-8")

    # Connect to server and send data
    sock.sendall(bytes(data2, encoding="utf-8"))

    # Receive data from Server
    received2 = sock.recv(1024)
    received2 = received2.decode("utf-8")

    sock.sendall(bytes(data3, encoding="utf-8"))

    # Receive data from Server
    received3 = sock.recv(1024)
    received3 = received3.decode("utf-8")

    sock.sendall(bytes(data4, encoding="utf-8"))

    # Receive data from Server
    received4 = sock.recv(1024)
    received4 = received4.decode("utf-8")

    sock.sendall(bytes(data5, encoding="utf-8"))

    # Receive data from Server
    received5 = sock.recv(1024)
    received5 = received5.decode("utf-8")

    sock.sendall(bytes(data6, encoding="utf-8"))

    # Receive data from Server
    received6 = sock.recv(1024)
    received6 = received6.decode("utf-8")

    sock.sendall(bytes(data7, encoding="utf-8"))

    # Receive data from Server
    received7 = sock.recv(1024)
    received7 = received7.decode("utf-8")

    sock.sendall(bytes(data8, encoding="utf-8"))

    # Receive data from Server
    received8 = sock.recv(1024)
    received8 = received8.decode("utf-8")

    sock.sendall(bytes(data9, encoding="utf-8"))

    # Receive data from Server
    received9 = sock.recv(1024)
    received9 = received9.decode("utf-8")

    sock.sendall(bytes(data10, encoding="utf-8"))

    # Receive data from Server
    received10 = sock.recv(1024)
    received10 = received10.decode("utf-8")

    sock.sendall(bytes(data11, encoding="utf-8"))

    # Receive data from Server
    received11 = sock.recv(1024)
    received11 = received11.decode("utf-8")

    sock.sendall(bytes(data12, encoding="utf-8"))

    # Receive data from Server
    received12 = sock.recv(1024)
    received12 = received12.decode("utf-8")

    sock.sendall(bytes(data13, encoding="utf-8"))

    # Receive data from Server
    received13 = sock.recv(1024)
    received13 = received13.decode("utf-8")

    sock.sendall(bytes(data14, encoding="utf-8"))

    # Receive data from Server
    received14 = sock.recv(1024)
    received14 = received14.decode("utf-8")

    # shut down connection
    
finally:
    sock.close()

# Display sent request and answer from the server
print("Sent:     {}".format(data))
print("Received: {}".format(received))

# Display sent request and answer from the server
print("Sent:     {}".format(data1))
print("Received: {}".format(received1))

# Display sent request and answer from the server
print("Sent:     {}".format(data2))
print("Received: {}".format(received2))

# Display sent request and answer from the server
print("Sent:     {}".format(data3))
print("Received: {}".format(received3))

# Display sent request and answer from the server
print("Sent:     {}".format(data4))
print("Received: {}".format(received4))

# Display sent request and answer from the server
print("Sent:     {}".format(data5))
print("Received: {}".format(received5))

# Display sent request and answer from the server
print("Sent:     {}".format(data6))
print("Received: {}".format(received6))

# Display sent request and answer from the server
print("Sent:     {}".format(data7))
print("Received: {}".format(received7))

# Display sent request and answer from the server
print("Sent:     {}".format(data8))
print("Received: {}".format(received8))

# Display sent request and answer from the server
print("Sent:     {}".format(data9))
print("Received: {}".format(received9))

# Display sent request and answer from the server
print("Sent:     {}".format(data10))
print("Received: {}".format(received10))

# Display sent request and answer from the server
print("Sent:     {}".format(data11))
print("Received: {}".format(received11))

# Display sent request and answer from the server
print("Sent:     {}".format(data12))
print("Received: {}".format(received12))

# Display sent request and answer from the server
print("Sent:     {}".format(data13))
print("Received: {}".format(received13))

# Display sent request and answer from the server
print("Sent:     {}".format(data14))
print("Received: {}".format(received14))