#  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
#  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
#  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
#  PARTICULAR PURPOSE.

# TESTED WITH PYTHON 3.9.5

import socket
import json

# Set the device name , here "Evolis Primacy" as in Devices and Printer (ex : Evolis Zenius (Copy 1), ...)
# Rfv = Request to read the firmware version
Rfv = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Rfv\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"5000\"}}"
# motor = Request to make the printer motor move
motor = "{\"jsonrpc\":\"2.0\",\"id\":\"1\",\"method\":\"CMD.SendCommand\",\"params\":{\"command\":\"Mc;+;1000\", \"device\":\"Evolis Primacy 2\", \"timeout\":\"120000\"}}"

# Localhost and default TCP API mode port, TCP enabled, modify these settings depending on your own configuration (IP of the server where the target Evolis Premium Suit is installed)
HOST, PORT = '127.0.0.1', 18200

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

try:
    # Connect to server and send data
    sock.connect((HOST, PORT))
    sock.sendall(bytes(Rfv, encoding="utf-8"))

    # Receive data from Server
    received = sock.recv(1024)
    received = received.decode("utf-8")

    # Connect to server and send data
    sock.sendall(bytes(motor, encoding="utf-8"))

    # Receive data from Server
    received1 = sock.recv(1024)
    received1 = received1.decode("utf-8")

    # shut down connection
finally:
    sock.close()

# Display sent request and answer from the server
print("Sent:     {}".format(Rfv))
print("Received: {}".format(received))

# Display sent request and answer from the server
print("Sent:     {}".format(motor))
print("Received: {}".format(received1))
