#ifndef _DEMO_H
#define _DEMO_H

#define NOMINMAX

#define OK "\033[1;32mSUCCESS\033[0m"
#define KO "\033[1;31mFAILED \033[0m"

#include <Windows.h>
#include <cstring>
#include <string>
#include <vector>

struct Data
{
    Data(const char* serverPipe, const char* modelName) {
        strcpy(this->serverPipe, serverPipe);
        strcpy(this->modelName, modelName);
        strcpy(this->printerName, "");
        quit = false;
        printerAvailable = false;
    }

    char serverPipe[128];
    char modelName[128];
    char printerName[128];
    bool quit;
    bool printerAvailable;
};

// helpers.cpp
bool demoOpen(const char* serverPipe, const char* printerName, HANDLE* comHandle, HANDLE* printerHandle);
void demoClose(HANDLE comHandle, HANDLE printerHandle);
std::vector<std::string> split(const std::string& s, char delimiter);
bool loadFile(const char* filePath, char** data, size_t* size);

// demo functions
void demoCleaningCycle(Data* data);
void demoMagEncoding(Data* data);
void demoPrintDuplex(Data* data);
void demoPrintSimplex(Data* data);
void demoPrintTestCard(Data* data);
void demoPrinterInfos(Data* data);
void demoRibbonInfos(Data* data);
void demoSendCommand(Data* data);
void demoSupervision(Data* data);
void demoSupportTools(Data* data);

#endif // _DEMO_H
