#include "demo.h"
#include "EvoSdk1Lib1.h"

#include <cstdio>

void demoCommunicationCheck(Data* d)
{
    HANDLE  printerHandle;
    HANDLE  comHandle;
    char*   answer = NULL;
    DWORD   errorCode;

    printf("=== COMMUNICATION CHECK  ===\n");
    printf(" >> PIPE:\n");
    errorCode = EPSDK_INTERNAL_ERROR;
    comHandle = EPSDK_GAPI_CreateCommunicationSettings(EPSDK_CT_Pipe, ".", d->serverPipe);
    if (NULL != comHandle) {
        printerHandle = EPSDK_GAPI_OpenPrinter(d->printerName, comHandle);
        if (NULL != printerHandle) {
            errorCode = EPSDK_SupportTools_ResetCommunication(printerHandle);
            printf(" -- Reset communication.      Status = %s\n", (errorCode == EPSDK_NO_ERROR) ? OK : KO);

            errorCode = EPSDK_SupportTools_SendCommand(printerHandle, "Rok", &answer);
            // errorCode and answer checked bellow.

            EPSDK_GAPI_ClosePrinter(printerHandle);
        }
        EPSDK_GAPI_DestroyCommunicationSettings(comHandle);
    }
    printf(" -- PIPE connection.          Status = %s\n", (errorCode == EPSDK_NO_ERROR && 0 == strcmp(answer, "OK")) ? OK : KO);

    printf(" >> TCP:\n");
    errorCode = EPSDK_INTERNAL_ERROR;
    comHandle = EPSDK_GAPI_CreateCommunicationSettings(EPSDK_CT_IP, "127.0.0.1", "18200");
    if (NULL != comHandle) {
        printerHandle = EPSDK_GAPI_OpenPrinter(d->printerName, comHandle);
        if (NULL != printerHandle) {
            errorCode = EPSDK_SupportTools_ResetCommunication(printerHandle);
            printf(" -- Reset communication.      Status = %s\n", (errorCode == EPSDK_NO_ERROR) ? OK : KO);

            errorCode = EPSDK_SupportTools_SendCommand(printerHandle, "Rok", &answer);
            // errorCode and answer checked bellow.

            EPSDK_GAPI_ClosePrinter(printerHandle);
        }
        EPSDK_GAPI_DestroyCommunicationSettings(comHandle);
    }
    printf(" -- TCP connection.           Status = %s\n", (errorCode == EPSDK_NO_ERROR && 0 == strcmp(answer, "OK")) ? OK : KO);
}

