#include "demo.h"
#include "EvoSdk1Lib1.h"

#include <cstdio>
#include <iostream>

void demoMagEncoding(Data* d)
{
    HANDLE comHandle;
    HANDLE printerHandle;
    char   c;

    if (demoOpen(d->serverPipe, d->printerName, &comHandle, &printerHandle)) {
        printf("=== MAG ENCODING API ===\n");
        printf(" ?? Please make sure your printer have a magnetic module then\n");
        printf(" ?? insert a card with magnetic track.\n");
        printf(" ?? Start demo (y/n) ? ");

        std::cin >> c;
        if (c == 'Y' || c == 'y') {
            const char* data[] = { "DATA", "1234", "5678" };
            char* reply;
            DWORD ec;

            ec = EPSDK_MagEncoding_SetIsoNorm(printerHandle, 1, EPSDK_IN_Iso1);
            printf(" >> Set isoNorm=%d on trackNb=%d.    %s (%d)\n",
                EPSDK_IN_Iso1, 1, (ec == EPSDK_NO_ERROR) ? OK : KO, ec);

            ec = EPSDK_MagEncoding_SetCoercivity(printerHandle, EPSDK_CO_Auto);
            printf(" >> Set coercivity to '%c'.         %s (%d)\n",
                EPSDK_CO_Auto, (ec == EPSDK_NO_ERROR) ? OK : KO, ec);

            for (int i = 0; i < 3; ++i) {
                ec = EPSDK_MagEncoding_SetTrackData(printerHandle, 1 + i, data[i]);
                printf(" >> Set data='%s' on track=%d.    %s (%d)\n",
                    data[i], 1 + i, (ec == EPSDK_NO_ERROR) ? OK : KO, ec);
            }

            ec = EPSDK_MagEncoding_WriteTrackData(printerHandle);
            printf(" >> Write data on track.           %s (%d)\n",
                (ec == EPSDK_NO_ERROR) ? OK : KO, ec);

            for (int i = 0; i < 3; ++i) {
                ec = EPSDK_MagEncoding_ReadTrackData(printerHandle, 1 + i, &reply);
                printf(" >> Read '%s' on track=%d.        %s (%d)\n",
                    reply, 1 + i, (ec == EPSDK_NO_ERROR) ? OK : KO, ec);
            }

            ec = EPSDK_SupportTools_MoveCard(printerHandle, EPSDK_CD_EjectCard);
            printf(" >> Ejecting card.                 %s (%d)\n",
                (ec == EPSDK_NO_ERROR) ? OK : KO, ec);
        } else {
            printf(" >> Skipped\n");
        }

        demoClose(comHandle, printerHandle);
    }
}

