#include "demo.h"
#include "EvoSdk1Lib1.h"

#include <cstdio>
#include <iostream>

void demoSendCommand(Data* d)
{
    HANDLE      comHandle;
    HANDLE      printerHandle;
    std::string command;
    char*       reply;
    DWORD       ec;

    if (demoOpen(d->serverPipe, d->printerName, &comHandle, &printerHandle)) {
        printf("=== SEND A CUSTOM COMMAND ===\n");

        while (command.empty()) {
            printf(" ?? Command to send to the printer: ");
            if (!(std::getline(std::cin, command))) {
                std::cin.clear();
                std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
            }
        }

        printf(" >> Sending command '%s' to the printer", command.data());
        ec = EPSDK_SupportTools_SendCommand(printerHandle, command.data(), &reply);
        printf(" -> %s (%d)\n", (ec == EPSDK_NO_ERROR) ? OK : KO, ec);
        printf(" -- reply = %s\n", reply);

        demoClose(comHandle, printerHandle);
    }
}
