﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using static DemoApp.EVOSDK1Enums;
using static DemoApp.EVOSDK1Wrapper;
using static DemoApp.Source_Files.Helpers;

namespace DemoApp.Source_Files {
    class demoInputModelName : ICommand {
        string ICommand.Description => "Change the target printer model";

        void ICommand.Execute(ref Data d, string address, string pipe_port) {

            Console.WriteLine("=== TARGET PRINTER MODEL ===");
            Console.WriteLine("Please input your printer model name : ");
            d.ModelName = Console.ReadLine();

            IntPtr handle = IntPtr.Zero;
            handle = Helpers.CreateCommunication(address, pipe_port);

            if (null != handle)
            {
                IntPtr reply = IntPtr.Zero;
                int ec;
                int index = 0;

                ec = EVOSDK1Wrapper.EPSDK_Supervision_EnumEvolisSupervisedPrinters(handle, 0, d.ModelName, ref reply);
                // If more than one printer available then "reply" will contain
                // a string like "<PRINTER-0>;<PRINTER-1>;<PRINTER-N>" with
                // <PRINTER-X> replaced with the name of the printer.

                if ((int)EPSDK_ReturnCode.EPSDK_NO_ERROR == ec)
                {

                    string printers = Marshal.PtrToStringAnsi(reply).ToString();
                    List<string> printerList = printers.Split(';').ToList();

                    if (0 == printerList.Count || printers == "")
                    {
                        Console.WriteLine(" >> No printer available for this model.");
                        d.PrinterAvailable = false;
                    }
                    else if (1 == printerList.Count)
                    {
                        Console.WriteLine(" >> Only one printer available.");
                        Console.WriteLine(" >> Selecting printer '{0}'", printerList.First().ToString());
                        d.PrinterAvailable = true;
                    }
                    else
                    {
                        int c = 0;
                        printerList.ForEach(x =>
                        {
                            Console.WriteLine(c + " - " + x.ToString());
                            c++;
                        });
                        Console.Write("Please choose a printer number and press Enter : ");
                        index = Convert.ToInt32(Console.ReadLine());
                        d.PrinterAvailable = true;
                    }

                    d.PrinterName = printerList.ElementAt(index);
                }

                EVOSDK1Wrapper.EPSDK_GAPI_DestroyCommunicationSettings(handle);
            }
        }
    }
}
