/**
 * @file
 * @author		Evolis Software Team
 * @version		3 oct. 2012
 */

/*
    This file is part of the Evolis EVOSDK1.

    The Evolis EVOSDK1 is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    The Evolis EVOSDK1 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with the Evolis EVOSDK1.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _EVOSDK1BASE_H_
#define _EVOSDK1BASE_H_

#ifdef EVOSDK1BASE_EXPORTS
#define EVOSDK1BASE_API __declspec(dllexport)
#else
#define EVOSDK1BASE_API __declspec(dllimport)
#endif

#include "EvoSdk1BaseDef.h"

//
// EvoSdk1Base layer related
//

extern "C" EVOSDK1BASE_API LPCSTR  EvoSdk1Base_GetVersion();
extern "C" EVOSDK1BASE_API LPCWSTR EvoSdk1Base_GetVersionW();

extern "C" EVOSDK1BASE_API VOID EvoSdk1Base_SetLogger(EVOSDK1BASE_PFN_Logger fnLogger);
extern "C" EVOSDK1BASE_API VOID EvoSdk1Base_EnableLog(INT loggerLevel);
extern "C" EVOSDK1BASE_API VOID EvoSdk1Base_DisableLog();
extern "C" EVOSDK1BASE_API BOOL EvoSdk1Base_PrintLog(INT loggerLevel, LPWSTR str, ...);

extern "C" EVOSDK1BASE_API VOID EvoSdk1Base_EncodeBinary(CONST LPBYTE binary, UINT size, LPSTR* encodedBuffer, UINT* encodedSize);
extern "C" EVOSDK1BASE_API VOID EvoSdk1Base_DecodeBinary(LPCSTR encodedBinary, LPBYTE* decodedBinary, UINT* size);

#endif /* _EVOSDK1BASE_H_ */
