/**
 * @file
 * @author		Evolis Software Team
 * @version		3 oct. 2012
 */

/*
    This file is part of the Evolis EVOSDK1.

    The Evolis EVOSDK1 is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    The Evolis EVOSDK1 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with the Evolis EVOSDK1.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _EVOSDK1BASEDEF_H_
#define _EVOSDK1BASEDEF_H_

///////////////////////////////////////////////////////////////////////////////
// Defines
///////////////////////////////////////////////////////////////////////////////

//
// Logger layer related
//

/// Maximum size for log message
#define EVOSDK1BASE_LOGGERMSG_MAXSIZE 2048

/// Logger levels
#define EVOSDK1BASE_LOGGERLEVEL_UNKNOWN	0	///< Unknown logger level 
#define EVOSDK1BASE_LOGGERLEVEL_OFF		1   ///< Off     logger level 
#define EVOSDK1BASE_LOGGERLEVEL_FATAL	2   ///< Fatal   logger level 
#define EVOSDK1BASE_LOGGERLEVEL_ERROR	3	///< Error   logger level 
#define EVOSDK1BASE_LOGGERLEVEL_WARN	4  	///< Warn    logger level 
#define EVOSDK1BASE_LOGGERLEVEL_INFO	5   ///< Info    logger level 
#define EVOSDK1BASE_LOGGERLEVEL_DEBUG	6   ///< Debug   logger level 

/// Typedef for logger logger function
typedef VOID (*EVOSDK1BASE_PFN_Logger)(INT loggerLevel, LPWSTR str, va_list arglist);

#endif  /* _EVOSDK1BASEDEF_H_ */
