/*
    This file is part of the Evolis SDK.

    The Evolis SDK is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    The Evolis SDK is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with the Evolis SDK.  If not, see <http://www.gnu.org/licenses/>.
*/

// HowToDbDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HowToDb.h"
#include "HowToDbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



// CHowToDbDlg dialog




CHowToDbDlg::CHowToDbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHowToDbDlg::IDD, pParent)
	, m_strStep1(_T(""))
	, m_strStep2(_T(""))
	, m_strStep3(_T(""))
	, m_strStep4(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHowToDbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_strStep1);
	DDX_Text(pDX, IDC_EDIT2, m_strStep2);
	DDX_Text(pDX, IDC_EDIT3, m_strStep3);
	DDX_Control(pDX, IDC_COMBO1, m_PrinterList);
	DDX_Text(pDX, IDC_EDIT4, m_strStep4);
}

BEGIN_MESSAGE_MAP(CHowToDbDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDCANCEL, &CHowToDbDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON1, &CHowToDbDlg::OnBnClickedButton1)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CHowToDbDlg::OnCbnSelchangeCombo1)
	ON_BN_CLICKED(IDC_BUTTON3, &CHowToDbDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CHowToDbDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CHowToDbDlg message handlers

BOOL CHowToDbDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	InitPrinterList();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHowToDbDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHowToDbDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CHowToDbDlg::OnBnClickedCancel()
{
	OnCancel();
}

void CHowToDbDlg::OnBnClickedButton1()
{
	CString OpenFilter;
	char chemin[MAX_PATH]="";
	char appName[20]="";	

	OpenFilter="Bitmap File (*.bmp)|*.bmp||";
	m_strBitmap = "";

	CFileDialog dlg(true,NULL,m_strBitmap,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,OpenFilter,AfxGetMainWnd());
	GetModuleFileName(NULL,chemin,MAX_PATH);
	CString Cchemin(chemin);
	strcpy(appName,AfxGetAppName());
	Cchemin = Cchemin.Mid(0,(Cchemin.Find(appName) + strlen(appName) + 1));
	dlg.m_ofn.lpstrInitialDir=Cchemin;

	if(dlg.DoModal()==IDOK)
    {
		m_strBitmap = dlg.GetPathName();	
	}
	if (m_strBitmap.GetLength()) m_strStep1 = "OK";
	else m_strStep1 = "";
	UpdateData(FALSE);
}

bool CHowToDbDlg::InitPrinterList()
{
	bool	bStatus = false;
	PRINTER_INFO_2 * InfoPrint=NULL;
	PRINTER_INFO_2 * InfoBase;
	PRINTER_INFO_2 * InfoMemory;
	DWORD	Receive, Nbre;
	DWORD	Need;
	int		i,j=0;
	
	EnumPrinters(PRINTER_ENUM_LOCAL, NULL, 2, (LPBYTE) InfoPrint,0, &Receive, &Nbre);
	Need = Receive;
	//memory allocation
	InfoMemory = InfoBase = InfoPrint = (PRINTER_INFO_2 * ) GlobalAlloc(GPTR, Need);
	i = EnumPrinters(PRINTER_ENUM_LOCAL, NULL, 2, (LPBYTE) InfoPrint, Need, &Receive, &Nbre);
	if (i)  {
		for(i=0; i < (int) Nbre; i++)  {
			if (strncmp(InfoPrint->pDriverName, "Evolis", 6) == 0) {
				m_PrinterList.AddString((LPSTR)InfoPrint->pPrinterName);
				j++;
			}		
			InfoPrint++;
		}
	}
	if(!i || !j) {
		m_strStep2 = "No printer available";
		UpdateData(FALSE);
		m_PrinterList.AddString("");
		bStatus = false;
	}
	else {
		bStatus = true;
	}
	
	m_PrinterList.SetCurSel(0);
	m_PrinterList.GetLBText(m_PrinterList.GetCurSel(),m_PrinterName);
	if (m_PrinterName.GetLength()) m_strStep2 = "OK";		
	//free memory
	GlobalFree(InfoMemory);
	return (bStatus);
}

void CHowToDbDlg::OnCbnSelchangeCombo1()
{
	m_PrinterList.GetLBText(m_PrinterList.GetCurSel(),m_PrinterName);
	if (m_PrinterName.GetLength()) m_strStep2 = "OK";
	else m_strStep2 = "";
	UpdateData(FALSE);
}

void CHowToDbDlg::OnBnClickedButton3()
{
	CString OpenFilter;
	char chemin[MAX_PATH]="";
	char appName[20]="";	

	OpenFilter="PRN File (*.prn)|*.prn||*";
	m_strPrnFile = "";

	CFileDialog dlg(true,NULL,m_strPrnFile,OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,OpenFilter,AfxGetMainWnd());
	GetModuleFileName(NULL,chemin,MAX_PATH);
	CString Cchemin(chemin);
	strcpy(appName,AfxGetAppName());
	Cchemin = Cchemin.Mid(0,(Cchemin.Find(appName) + strlen(appName) + 1));
	dlg.m_ofn.lpstrInitialDir=Cchemin;

	if(dlg.DoModal()==IDOK)
    {
		m_strPrnFile = dlg.GetPathName();	
	}
	PrintToFile();
}

void CHowToDbDlg::PrintToFile()
{
	unsigned char *		lpMem = NULL;
	long				fileSize;
	BITMAPINFOHEADER	InfoHead;
	CFile				outputFile;
	char				color[] = {'y','m','c',0x00};
	bool				bRes; 
	unsigned char*		command;
	long				lCommandSize; 
	int					numberOfByteToWrite = 0;
	bool				bStatus				= true;
	int					i					= 0;
	
	m_strStep3	= "";
	UpdateData(false);
	
	// Open the output file
	
	if (m_strPrnFile.GetLength() == 0) 
	{
		MessageBox("Please select a file");
		return;
	}
	else
	{
		if (!outputFile.Open(m_strPrnFile, CFile::modeCreate|CFile::modeWrite))
		{
			MessageBox("Fail to open output file");
			outputFile.Close();
			return;
		}
		outputFile.Write( PRN_HEADER, PRN_HEADERSZ );
	}
	
	// Open the BMP File to get data size
	
	if (m_strBitmap.GetLength() == 0) 
	{
		MessageBox("Please select a bitmap");
		outputFile.Close();
		return;
	}
	
	bRes = OpenBmp(m_strBitmap.GetBuffer(),NULL,&(fileSize),&InfoHead);
	if( (!bRes) || (fileSize<=0) ) {
		MessageBox("Fail to open bitmap");
		outputFile.Close();
		return;
	}	
	
	// Memory Management
	
	lpMem = new unsigned char[fileSize];
	if(!lpMem) {
		MessageBox("Error Memory (1)");
		outputFile.Close();
		return;
	}
	
	// Read Data
	
	if(!OpenBmp(m_strBitmap.GetBuffer(),lpMem,&(fileSize),&InfoHead)) {
		MessageBox("Fail to open bitmap");
		delete(lpMem);
		outputFile.Close();
		return;
	}

	// Black panel pre-computation

	KinYMC(lpMem,InfoHead.biHeight,InfoHead.biWidth);

	lCommandSize= (1016*648)+19;   // 19 is the printing command length (Dbc) without binary data
	command = new unsigned char[lCommandSize];
		
	if (!command) {
		MessageBox("Error Memory (2)");
		delete(lpMem);
		outputFile.Close();
		return;
	}
	else {
	
		//Download Y, M and C panels
		for(int i = 0; i < 3; i++) {
			numberOfByteToWrite = DB128C(lpMem,i*((fileSize)/5),color[i],command,lCommandSize,false,0,0);
			outputFile.Write( command, numberOfByteToWrite );
		}
		
		delete [] command;
			
		lCommandSize = (1016*648)/8;
		command = new unsigned char[lCommandSize + 9];
		
		if (!command) {
			MessageBox("Error Memory (3)");
			delete(lpMem);
			outputFile.Close();
			return;
		}
		
		// black pannel
		
		numberOfByteToWrite = DB2C(lpMem,3*((fileSize)/5),"ABP",command,lCommandSize);
		outputFile.Write( command, numberOfByteToWrite );
	
		// overlay pannel

		numberOfByteToWrite = DB2C(lpMem,0,"FO",command,lCommandSize);
		outputFile.Write( command, numberOfByteToWrite );			
	}

	delete (lpMem); 	
	delete [] command;
	
	outputFile.Write( PRN_TAIL, PRN_TAILSZ );
	outputFile.Close();
	
	m_strStep3	= "OK";
	UpdateData(false);
}

void CHowToDbDlg::OnBnClickedButton4()
{
	CFile inputFile;
	HANDLE hPrinter = NULL;
	UINT sz, inputsz;
	unsigned char* buffer = NULL;
	
	hPrinter=OpenPebble(m_PrinterName.GetBuffer());
	if (!hPrinter) {
		MessageBox("Fail to open printer");
		return;
	}
	if (!inputFile.Open(m_strPrnFile, CFile::modeRead))
	{
		MessageBox("Fail to open prn file");
		ClosePebble(hPrinter);
		return;
	}
	inputsz = inputFile.GetLength();
	buffer = new unsigned char[inputsz];
	while ((sz=inputFile.Read(buffer,inputsz))==inputsz)
	{
		if (!WritePebble( hPrinter, (LPSTR) buffer, sz )) 
		{	
			MessageBox("Communication with printer failed");
			inputFile.Close();
			ClosePebble(hPrinter);
			return;
		}
	}
		
	inputFile.Close();
	ClosePebble(hPrinter);
	m_strStep4 = "OK";
	UpdateData(FALSE);
}
