## Abstract

This project shows how to directly print a card (without using the print spooler) from a Bitmap image.
Keywords: Dbc ; bitmap ; Graphics conversion; color

## Scope

To make it simple and easy to understand, the code provided in this SDK serves as an example to illustrate a given topic in the most schematically possible way.
Thus, this code should not be used as is, but customized to the requirement of the target application. Pay attention to use the lastest iomem?dll release (Install Evolis Premium Suite from evolis website) and get the 

## Instruction

Compile the project.
Run the program : bin/HowtoDb.exe.
Then, select an image.
The format of the 24-bit bitmap image MUST be 1016 x 648.

Select your Evolis printer from the list.
Select the file which contains the graphic data to be sent to the printer.
Press 'Send file to printer' to print the card.

## Description

The goal of this project is to show how to produce graphic data compatible with the Evolis printers, and from a standard-based graphic (see also project 001-001).
The core of this project is handled by the following function:

void CHowToDbDlg::PrintToFile()
The main issue here is to extract graphic data related to the panels and from a bitmap file. This is carried out, at the pixel level, and through the following function :

int DB128C(unsigned char*, long, char, unsigned char*, long, int, long, long);
The order in which the Dbc commands are sent to the printer is important. It must comply with how panels are ordered on the used ribbon (for example Yellow->Magenta->Cyan->Black->Varnish for the R3011 ribbon).

Processing the black panel is different. The image must be processed according to the selected option (here, the selected option is “ABP”, which is equivalent to the All Black Points option featured in the driver.

KinYMC(lpMem,InfoHead.biHeight,InfoHead.biWidth);
[...]

numberOfByteToWrite = DB2C(lpMem,3*((fileSize)/5),"ABP",command,lCommandSize);
outputFile.Write( command, numberOfByteToWrite );

To make things simple, the image format is fixed and is a 1016x648 bitmap (24-bit) but Project 10 shows how to overcome this restriction.

## Dependency

Communication with the Evolis printers is done thanks to the iomem.dll library. For Ethernet communications, check that the iomem version is 4.9.37.0 or later.
