/*
    This file is part of the Evolis SDK.

    The Evolis SDK is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    The Evolis SDK is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with the Evolis SDK.  If not, see <http://www.gnu.org/licenses/>.
*/

// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once
#define _CRT_SECURE_NO_WARNINGS 1
#include "targetver.h"

#include <stdio.h>
#include <tchar.h>
#include <windows.h>
#include "FreeImage.h"


#define NO_ERR			0
#define ERR_MEM			1
#define ERR_IO			2
#define	ERR_BMP			3
#define ERR_USAGE		4

#define FLAG_INPUT			1
#define FLAG_OUTPUT			2
#define FLAG_POSX			4
#define FLAG_POSY			8
#define FLAG_OPT_UNIT		16
#define FLAG_CONV			32


#define FLAG_GOOD_ARGS (FLAG_INPUT | FLAG_POSX | FLAG_POSY | FLAG_OUTPUT)

#define	BMP_CARD_SIZE	1016 * 648 * 5
#define	PIX_CARD_SIZE	1016 * 648

#define MAX(a,b) ((a)>(b)) ? (a) : (b)
#define MIN(a,b) ((a)>(b)) ? (b) : (a)

int parseCommandLine(int argc, char* argv[], char** pInputfile, char** pOutputfile, int* x, int* y, int *flag);
void print_usage();
int OpenBmp(char *pPathFile, unsigned char **pMem, int offsetX, int offsetY);
int OpenBmpEx(char *pPathFile, unsigned char **pMem, int offsetX, int offsetY);
void FillCardMem(unsigned char *pCard, unsigned char *pPhoto, long dx, long dy, int x, int y);
int DB128C(unsigned char * lpMem, long lPos, char color, unsigned char *ucCommand, long lCommandSize, int bPartial, long Min, long Max);
void thenth2dot(int* x);
void ebcdic_to_ascii (int len, unsigned char *buffer);