﻿//
// File    : CardDesigner.cs
// Author  : Evolis Card Printer
// History :
// 
//    19th feb 2013 - file creation
//

namespace SupervisorLayer
{
    /// <summary>
    /// In charge of making conversion between binary status (from device) to user oriented device status
    /// </summary>
    interface IPrinterStatusHelper
    {
        IPrinterStatusHelperError Update(byte[] answer);
        string GetPrinterAnswer(); 
        bool IsPrinterClaimed();  
        bool IsPrinterBusy(); 
        bool IsChipStationAvailable(); 
        bool IsCardAvailable(); 
        bool IsCoverOpened();
        bool IsRibbonDetected();
        bool IsRibbonWellDefined();
        bool IsEndOfRibbon();
        bool IsErrorPrintHead();
        bool IsErrorCover();
        bool IsErrorRibbon();
        bool IsErrorFeeder();
        bool IsErrorMechanical();
        bool IsCardInPrinter();
        string Info();
    }

    public enum IPrinterStatusHelperError
    {
        NullData,
        DecodingError, 
        EmptyStatus,
        MemoryError, 
        NoError
    }
}
