#include <jni.h>
#include "IomemJNI.h"

#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#include <iostream.h>


_declspec(dllimport)	HANDLE	FAR PASCAL OpenPebble(char *);
_declspec(dllimport)	BOOL	FAR PASCAL ClosePebble(HANDLE);
_declspec(dllimport)	BOOL	FAR PASCAL ReadPebble(HANDLE, LPSTR, DWORD, LPDWORD);
_declspec(dllimport)	BOOL	FAR PASCAL WritePebble(HANDLE, LPSTR, DWORD);      
_declspec(dllimport)	BOOL	FAR PASCAL GetIomemVersion(LPSTR); 
_declspec(dllimport)	DWORD	WaitBusy;          
_declspec(dllimport)	DWORD	FAR PASCAL GetTimeout(void); 
_declspec(dllimport)	BOOL	FAR PASCAL SetTimeout(DWORD); 




JNIEXPORT jint JNICALL Java_IomemJNI_OpenPebble(JNIEnv * env, jclass hPrinter, jstring DriverName)
{
	HANDLE hMapFile = NULL;
	//LPCSTR lpName = env->GetStringUTFChars(DriverName, NULL);
	
	const char *str = (*env)->GetStringUTFChars(env, DriverName, 0);


	printf("Java_IomemJNI_OpenPebble\n");

	
	hMapFile = OpenPebble((char *)str);

	   
	printf("%s : %d\n", str,hMapFile);
    (*env)->ReleaseStringUTFChars(env, DriverName, str);
	
    return (jint) (hMapFile);
}
JNIEXPORT jboolean JNICALL Java_IomemJNI_ClosePebble(JNIEnv *env, jclass hPrinter, jint in)
{

	printf("ClosePebble : %d\n", in);
	ClosePebble((HANDLE) in);
    return 1;
}

JNIEXPORT jboolean JNICALL Java_IomemJNI_WritePebble(JNIEnv *env, jclass hPrinter, jint nExpWr, jstring EscCde, jint nWr)
{
	HANDLE hMapFile = (HANDLE) nExpWr;
	const char *str = (*env)->GetStringUTFChars(env, EscCde, 0);
	int	nb =nWr;

	printf("Java_IomemJNI_WritePebble!\n");
	printf("command %s caracter %d \n",str, nb);

	WritePebble(hMapFile,(LPSTR) str, (DWORD)nb);   

    return 1;
}

JNIEXPORT jint JNICALL Java_IomemJNI_GetTimeout(JNIEnv *env, jclass hPrinter)
{
	 printf("Java_IomemJNI_WritePebble\n");
    return 1;

}
JNIEXPORT jboolean JNICALL Java_IomemJNI_SetTimeout(JNIEnv *env, jclass hPrinter, jint Timeout)
{
	 printf("Java_IomemJNI_SetTimeout\n");
    return 1;
}

JNIEXPORT jboolean JNICALL Java_IomemJNI_ReadPebble(JNIEnv *env, jclass hPrinter, jint nRdExp, jstring Answer, jint nRd, jintArray inA)
{
	HANDLE hMapFile = (HANDLE) nRdExp;
	//const char *str = (*env)->GetStringUTFChars(env, Answer, 0);

	char ann[512];
	DWORD nBytesToRead =nRd;
	DWORD nBytesRead = 0;
	printf("Java_IomemJNI_ReadPebble!\n");
	printf("%d  %d \n",hMapFile,nBytesToRead);
	
	ReadPebble(hMapFile, (LPSTR) ann, nBytesToRead, &nBytesRead);

	(*env)->GetStringUTFChars(env, Answer, 0);

	printf("%s %d\n",ann,nBytesRead);

	Answer = (*env)->NewStringUTF(env, ann);

    return 1;
}