/*
    This file is part of the Evolis SDK.

    The Evolis SDK is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    The Evolis SDK is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with the Evolis SDK.  If not, see <http://www.gnu.org/licenses/>.
*/

// trySDK.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "windows.h"
#include "winspool.h"
#include "EvoGdi.h"
 
void PrintSample();
void NewCard(
		LPTSTR pEvolisPrinterName, 
		LPTSTR pSubscriberID, 
		LPTSTR pSubscriberID2, 
		LPTSTR pSubscriberID2text, 
		LPTSTR pSubscriberNames,  
		LPTSTR pExpiryDate,
		LPTSTR pItemsCount
	) ;

int _tmain(int argc, _TCHAR* argv[])
{
	NewCard( 
		TEXT("Evolis Pebble"), 
		TEXT("N A 025125"),
		TEXT("*458666548752*"),
		TEXT("4  5  8  6  6  6  5  4  8  7  5  2"),
		TEXT("Xavier Romain"),
		TEXT("01012011"),
		TEXT("10")
	);

	printf("press a key ...\n");
	getchar();
	return 0;
}


// 
// Example from the tutorial 
//
void NewCard(
		LPTSTR pEvolisPrinterName, 
		LPTSTR pSubscriberID, 
		LPTSTR pSubscriberID2, 
		LPTSTR pSubscriberID2text, 
		LPTSTR pSubscriberNames,  
		LPTSTR pExpiryDate,
		LPTSTR pItemsCount
	) 
{ 
	EvolisCard myCard; 
	Evolis_DriverPrint_OpenCard		( &myCard, pEvolisPrinterName ); 
	Evolis_DriverPrint_SetTextAttrib( &myCard, 50, 0, 0, FW_NORMAL, 0, 0, TEXT("Arial") ); 
	Evolis_DriverPrint_AddText		( &myCard, pSubscriberNames, 60, 490 ); 
	Evolis_DriverPrint_AddText		( &myCard, pSubscriberID, 60, 550 ); 
	Evolis_DriverPrint_SetTextAttrib( &myCard, 140, 20, 00, FW_NORMAL, 0, 0, TEXT("3 of 9 Barcode") ); 
	Evolis_DriverPrint_AddText		( &myCard, pSubscriberID2, 650, 400 );
	Evolis_DriverPrint_SetTextAttrib( &myCard, 25, 0, 0, FW_NORMAL, 0, 0, TEXT("Arial") ); 
	Evolis_DriverPrint_AddText		( &myCard, pSubscriberID2text, 650, 540 );
   	Evolis_DriverPrint_MagEncode	( &myCard, pSubscriberID2, pExpiryDate, pItemsCount ); 
	Evolis_DriverPrint_PrintCard	( &myCard ); 
} 

void PrintSample()
{
	EvolisCard myCard;
	//
	// Please, replace Evolis Pebble by the printer name
	// for Printers Enumeration see http://msdn.microsoft.com/en-us/library/ms536005(VS.85).aspx
	// and the Evolis SDK application example
	// 
	Evolis_DriverPrint_OpenCard		( &myCard, TEXT("Evolis Pebble") );
	//
	// add a bitmap in the rectangle which upper leftmost point is (0,0) 
	// and with edges size 1016 (horizontal edge) and 648 (vertical edge)
	//
	//Evolis_DriverPrint_AddBitmap	( &myCard, TEXT("..\try.bmp"), 0, 0, 1016, 648 );
	//
	// Select the font Arial (4pt) horizontal orientation, FW_NORMAL height, no underline, no italic
	//
	Evolis_DriverPrint_SetTextAttrib( &myCard, 40, 0, 0, FW_NORMAL, 0, 0, TEXT("Arial") );
	//
	// write hello word at the point (10,400)
	//
	Evolis_DriverPrint_AddText		( &myCard, TEXT("Hello word"), 10, 400 );
	//
	// Select font Comic Sans MS 5pt horizontal orientation Bold no underline no italic
	//
	Evolis_DriverPrint_SetTextAttrib( &myCard, 40, 0, 90, FW_BOLD, 0, 0, TEXT("Comic Sans MS") );
	//
	// Change the text foreground color (red) and the backgroung color (grey)
	//
	Evolis_DriverPrint_SetColors	( &myCard, RGB(255, 0, 0), RGB(200, 200, 200) );
	//
	//	write hello word vertically from the point (400,390)
	//
    Evolis_DriverPrint_AddText		( &myCard, TEXT("Hello word"), 400, 390 );
    //
    // Encode Track 1, 2 and 3 (the encoding settings is done via the printer properties pages)
    //
    Evolis_DriverPrint_MagEncode	( &myCard, "123456789", "123", "456" );
    //
    // select the line thickness 20pt and the color grey
    //
    Evolis_DriverPrint_SetLineAttrib( &myCard, 20, RGB(100,100,100) );
    //
    // draw a line from the point (10,405) to the point (600, 405)
    //
    Evolis_DriverPrint_AddLine		( &myCard, 10, 405, 600, 405 );
    //
    // select the line thickness 1pt and the color black
    //
    Evolis_DriverPrint_SetLineAttrib( &myCard, 1, RGB(0,0,0) );
    //
    // draw a rectangle (filled by the color red)
    //
    Evolis_DriverPrint_AddRectangle	( &myCard, RGB(255,0,0), 510, 10, 550, 20 );
    //
    //	draw an ellipse inscribed in the rectangle define by the points (10, 600), (40, 648)
    //	and filled by the green color
    //
    Evolis_DriverPrint_AddEllipse	( &myCard, RGB(0,200,0),10, 600, 40, 648 );
    //
    // Print the card
    //
	Evolis_DriverPrint_PrintCard	( &myCard );
}
