## Abstract

Purpose of this project is to present a library and a simple example of application. The EvoGDI library offers functions that make it easier to create graphics for cards (the functions of Windows GDI are adapted), conduct magnetic personalization, and print via the print spooler.

**Keywords:** GDI ; magnetic encoding

## Scope

To make it simple and easy to understand, the code provided in this SDK serves as an example to illustrate a given topic in the most schematically possible way.

Thus, this code should not be used as is, but customized to the requirement of the target application.

## Instructions

In addition to a library, the sample program detailled in the tutorial is presented (NewCard function from the main.cfile). 
A more advanced example is also explained in the PrintSample function of main.c.

1. Open the project in your development environment.
2. Edit the printer name according to your printer.
3. Execute the project

## Description

EvoGDI library is dedicated to card production and magnetic personalization, and thus centered on a EvolisCard structure which is the guiding force for the card production process.

This data structure offers all the information related to card production, including errors experienced during the creation process.

The base process if the following:

Call Evolis_DriverPrint_OpenCard : initializes the card creation process and link the card to a printer in the print spooler.
Call various card graphic design functions (for example : Evolis_DriverPrint_AddText) or add magnetic data Evolis_DriverPrint_MagEncode)
Call Evolis_DriverPrint_PrintCard : launches the print job and then frees the resources attached to the EvolisCard structure.
The EvoGDI library implements the following functions:
Evolis_DriverPrint_OpenCard : initializes the card creation process
Evolis_DriverPrint_PrintCard : prints the card and frees the resources used
Evolis_DriverPrint_AddBitmap : adds a Bitmap image on the card
Evolis_DriverPrint_SetTextAttrib : sets the text attributes as per the Windows (GDI) standards
Evolis_DriverPrint_SetColors : set colors as per the Windows (GDI) standards
Evolis_DriverPrint_AddText : adds text to the card image
Evolis_DriverPrint_MagEncode : attaches magnetic data to the card
Evolis_DriverPrint_SetLineAttrib : defines attributes for lines as per the Windows (GDI) standards
Evolis_DriverPrint_AddLine : adds a line to the card image
Evolis_DriverPrint_AddEllipse : adds an ellipse to the card image
Evolis_DriverPrint_AddRectangle : adds a rectangle to the card image
Evolis_DriverPrint_AddFormatedText : adds formatted text to the card image

**Please read comments in the evogdi.h file for more technical information.**
