//
//  ViewController.swift
//  PremiumSdkClient
//
//  Created by evolis on 18/09/2015.
//  Copyright © 2015 evolis. All rights reserved.
//

import UIKit

class ViewController: UIViewController, NSStreamDelegate {

    @IBOutlet weak var ipAdressTextField: UITextField!
    @IBOutlet weak var requestTextView: UITextView!
    @IBOutlet weak var answerTextView: UITextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: Stream delegate
    
    func stream(aStream: NSStream, handleEvent eventCode: NSStreamEvent) {
        switch(eventCode){
        case NSStreamEvent.OpenCompleted: break
        case NSStreamEvent.ErrorOccurred: break
        case NSStreamEvent.EndEncountered:
            aStream.close()
            aStream.removeFromRunLoop(NSRunLoop.currentRunLoop(), forMode: NSDefaultRunLoopMode)
            break
        case NSStreamEvent.HasBytesAvailable:
            var buffer = [UInt8](count:1024, repeatedValue:0)
            let count = (aStream as! NSInputStream).read(&buffer, maxLength: 1024)
            answerTextView.text = NSString(bytes: buffer, length: count, encoding: NSUTF8StringEncoding) as! String

            break
        default:
            break
        }
    }
    
    // MARK: Send function
    
    func sendToEspf(request : String, ipAddress : String) -> String {
        var inputStream : NSInputStream?
        var outputStream : NSOutputStream?
        var readStream : Unmanaged<CFReadStreamRef>?
        var writeStream : Unmanaged<CFWriteStreamRef>?
        var result : String
        
        CFStreamCreatePairWithSocketToHost(kCFAllocatorDefault, ipAddress, 18000, &readStream, &writeStream)
        inputStream = readStream!.takeUnretainedValue()
        outputStream = writeStream!.takeUnretainedValue()
        inputStream!.open()
        outputStream!.open()
        
        //let data: NSData = request.dataUsingEncoding(NSUTF8StringEncoding, allowLossyConversion:true)!
        let encodedArray = [UInt8](request.utf8)
        //var buffer = [UInt8](count: data.length, repeatedValue: 0)
        //data.getBytes(&buffer)
        outputStream!.write(encodedArray, maxLength: encodedArray.count)
        
        // var buffer = [UInt8](count:1024, repeatedValue:0)
        
        inputStream?.delegate = self
        inputStream?.scheduleInRunLoop(NSRunLoop.currentRunLoop(), forMode: NSDefaultRunLoopMode)
        
        result = "In progress ..."
        //while inputStream!.hasBytesAvailable {
        //    let count = inputStream!.read(&buffer, maxLength: 1024)
        //    result = NSString(bytes: buffer, length: count, encoding: NSUTF8StringEncoding) as! String
        //}
        
        //inputStream!.close()
        outputStream!.close()
        
        return result
    }
    
    // MARK: Actions
    
    @IBAction func endEditIpAddress(sender: UITextField) {
        sender.resignFirstResponder()
    }
    
    @IBAction func sendAction(sender: UIButton) {
        requestTextView.resignFirstResponder()
        answerTextView.text = ""
        //dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), {
        //    let answer =
        self.sendToEspf(self.requestTextView.text, ipAddress: self.ipAdressTextField.text!)
        //    dispatch_async(dispatch_get_main_queue(), {
        //            self.answerTextView.text = answer;
        //        })
        //})
    }
}